Summary: Boss Python SkyNET
Name: python-boss-skynet
Version: 0.6.3
Release: 1.3%{?dist}
Source0: %{name}-%{version}.tar.gz
License: UNKNOWN
Group: Development/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Prefix: %{_prefix}
Obsoletes: boss-skynet < 0.6.0
Provides: boss-skynet
BuildRequires: python, python-distribute, supervisor
Requires: python, python-ruote-amqp >= 2.1.0, python-amqplib, supervisor, python-setproctitle
Requires(post): /usr/sbin/useradd
BuildArch: noarch
Vendor: David Greaves <david@dgreaves.com>
Url: http://github.com/lbt/boss-python-skynet/

%description
UNKNOWN

%prep
%setup -n %{name}-%{version} -n %{name}-%{version}

%build
make

%install
make PREFIX=%{_prefix} DESTDIR=%{buildroot} install
mkdir -p %{buildroot}/var/log/supervisor
chmod 770 %{buildroot}/var/log/supervisor

%clean
rm -rf $RPM_BUILD_ROOT

%pre
    # the only crazy way for rpm
    if [ "$(head -n 1 /usr/bin/skynet)" == '#!/bin/bash' ]; then
      # Upgrade from daemontools based version
      SERVICE_DIR=/var/lib/SkyNET/services/
      STORAGE_DIR=/var/lib/SkyNET/store/
      [ -f /etc/sysconfig/boss-skynet ] && . /etc/sysconfig/boss-skynet
      echo "stopping daemontools controlled participants ... this may take a while ..."
      for PART in $(find ${SERVICE_DIR} -type l); do
        rm $PART
        svc -dx ${STORAGE_DIR}/$(basename $PART)
        sleep 2
        svc -dx ${STORAGE_DIR}/$(basename $PART)/log
      done
    fi



%post

chkconfig supervisord on || true
service supervisord start || true

if [ $1 -eq 1 ]; then
    if ! grep "skynet" /etc/passwd; then
      /usr/sbin/useradd --system skynet
    fi

else
    if [ "$(head -n 1 /usr/bin/skynet)" == '#!/bin/bash' ]; then
        # Upgrade from daemontools based version to supervisor based version

        for PART in $(find /var/lib/SkyNET/store -maxdepth 2 -name config.exo); do
            code=$(awk -F "=" '/^code/ {print $2}' ${PART})
            name=$(awk -F "=" '/^name/ {print $2}' ${PART})
            queue=$(awk -F "=" '/^queue/ {print $2}' ${PART})
            runas=$(awk -F "=" '/^runas/ {print $2}' ${PART})
            regexp=$(awk -F "=" '/^regexp/ {print $2}' ${PART})
            if ! grep -R -q $code /etc/supervisor/conf.d/ ; then
                skynet install -u $runas -r $regexp -q $queue -n $name $code
            fi
            sed -i -e '/user_managed/d' /etc/supervisor/conf.d/*
        done

    else
        # Upgrade from supervisord based version

        skynet rebuild --all || true
        skynet apply || true
    fi
fi

%files
%defattr(-,root,root)
%{python_sitelib}/SkyNET
%{python_sitelib}/*egg-info
%{_datadir}/doc/%{name}
%{_bindir}/skynet
%{_bindir}/skynet_exo
%config(noreplace) %{_sysconfdir}/skynet/skynet.conf
%config(noreplace) %{_sysconfdir}/skynet/skynet.env
%{_sysconfdir}/skynet
%dir /var/log/supervisor
%changelog
* Thu Oct 17 2013 Oleg Girko <ol@infoserver.lv>
- Change permissions of /var/log/supervisor to match ones of supervisor
* Thu Oct 17 2013 Oleg Girko <ol@infoserver.lv>
- Require /usr/sbin/useradd instead of pwdutils for better portability
* Wed Jan 18 2012 Islam Amer <islam.amer@nokia.com> - 0.6.2-1
- Minor bugfixes.
* Tue Jan 10 2012 Islam Amer <islam.amer@nokia.com> - 0.6.1-1
- Various fixes and enhancements
* Tue Jan  3 2012 Islam Amer <islam.amer@nokia.com> - 0.6.0-1
- New supervisor based boss-skynet merged into python-boss-skynet
* Mon Dec 19 2011 Richard Braakman <ext-richard.braakman@nokia.com> - 0.5.0-1
- Trace logging: emit one log line per workitem in Exo.consume()
* Tue Nov  8 2011 Pami Ketolainen <ext-pami.o.ketolainen@nokia.com> - 0.4.1-1
- Import participant code instead of execfile (PMO#288873)
* Thu Oct 27 2011 Pami Ketolainen <ext-pami.o.ketolainen@nokia.com> - 0.4.0-1
- Handle debug_dump in Exo.consume()
* Wed Sep 28 2011 Pami Ketolainen <ext-pami.o.ketolainen@nokia.com> - 0.3.1-1
- Handle participant shutdown more gracefully
- [uwe] fixed example-notify-participant
* Fri Aug 19 2011 Islam Amer <islam.amer@nokia.com> - 0.3.0-2
- Sphinx documentation
- use new RuoteAMQP reply_to_engine() that takes a workitem keyword
  parameter
- Modify gbp.conf
- Correct the send-to-engine mechanism
* Tue May  3 2011 David Greaves <david@dgreaves.com> - 0.2.2-2
- Tuple-triple confusion : now Depends on python-ruote-amqp >= 2.0.0
* Tue May  3 2011 David Greaves <david@dgreaves.com> - 0.2.2-1
- Update to use property based python-ruote-amqp
- Depends on python-ruote-amqp >= 0.2.1
* Wed Apr 20 2011 David Greaves <david@dgreaves.com> - 0.2.1-1
- Adopt the ruby rational versioning policy
- support participant config in /etc/skynet/<name>.conf
* Wed Apr 13 2011 David Greaves <david@dgreaves.com> - 0.2-7
- Use the config.exo queue attribute
* Thu Apr  7 2011 David Greaves <david@dgreaves.com> - 0.2-6
- Merge branches
* Tue Apr  5 2011 Islam Amer <islam.amer@nokia.com> - 0.2-5
- Fix some lintian warnings.
* Mon Mar 28 2011 David Greaves <david@dgreaves.com> - 0.2-4
- Use /etc/skynet/skynet.conf as the default config file
* Mon Mar 28 2011 David Greaves <david@dgreaves.com> - 0.2-3
- python-ruote-amqp-pyclient is now python-ruote-amqp
* Fri Mar 25 2011 David Greaves <david@dgreaves.com> - 0.2-2
- Update setup.py
* Thu Mar 24 2011 David Greaves <david@dgreaves.com> - 0.2-1
- Sample participants used in the BOSS installation guide
- consume() doesn't take a workitem - handle_wi() does
- Minor mods for git-buildpackage
- Extend README to include light installation and setup information
* Wed Mar  2 2011 David Greaves <david@dgreaves.com> - 0.1-1
- source package initially created by stdeb 0.6.0+git
